Subject: bug#70440: [PATCH] Use -P switch when calling 'python-interpreter'

From: Augusto Stoffel <[email-masked]>
Date: Thu, 18 Apr 2024 18:02:34 +0200

On Thu, 18 Apr 2024 at 18:57, Eli Zaretskii wrote:

>> From: Augusto Stoffel <[email-masked]>
>> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
>> Date: Thu, 18 Apr 2024 17:52:21 +0200
>> 
>> On Fri, 19 Apr 2024 at 00:25, kobarity wrote:
>> 
>> > The -P switch is new, introduced in CPython 3.11, so I don't think it
>> > can be added unconditionally.  Furthermore, `python-interpreter' may
>> > not be CPython.  Isn't it enough to customize
>> > `python-interpreter-args'?
>> 
>> Ah, too bad.  So let's send that option via environment variables.  I'll
>> make a new patch when I get the chance.
>
> Maybe we should discuss this before you sit down to write and text the
> code.  Pushing things into the environment has its downsides: those
> environment variables then affect all the subordinate processes,
> including their children, grandchildren etc.  This is not always
> wanted.

In this case we would just let-bind the env variable for this specific
subprocess call only.  It's no different than passing a command-line
switch.

> One alternative to environment variables would be detecting whether -P
> is supported before the first time we invoke Python.  We do similar
> stuff for Grep and other programs we invoke.